if importPath==nil then importPath=string.gsub(getfenv(1)._.Name,"%.FontSupport","").."." end
if resourcePath==nil then resourcePath=string.gsub(importPath,"%.","/").."Resources/" end
-- create a listbox for selecting font from all of the known fonts
if Turbine==nil then
	import "Turbine"
end
if Turbine.UI==nil then
	import "Turbine.UI"
end
if Turbine.UI.Lotro==nil then
	import "Turbine.UI.Lotro"
end
-- now add the undocumented fonts to the fonts table
if Turbine.UI.Lotro.Font.TimesRoman12==nil then
	Turbine.UI.Lotro.Font.TimesRoman12=0x42000021
end
if Turbine.UI.Lotro.Font.TimesRoman20==nil then
	Turbine.UI.Lotro.Font.TimesRoman20=0x4200000e
end

if Turbine.UI.Lotro.Font.TimesRoman22==nil then
	Turbine.UI.Lotro.Font.TimesRoman22=0x4200000f
end
if Turbine.UI.Lotro.Font.TimesRoman24==nil then
	Turbine.UI.Lotro.Font.TimesRoman24=0x42000010
end
if Turbine.UI.Lotro.Font.Calibri14==nil then
	Turbine.UI.Lotro.Font.Calibri14=0x4200002b
end

Turbine.UI.Lotro.FontInfo={} -- table for extended font information
for k,v in pairs(Turbine.UI.Lotro.Font) do
	local name=tostring(k)
	local i=string.find(name,"%d")
	if i~=nil then
		local size=tonumber(string.sub(name,i))
		name=string.sub(name,0,i-1)
		i=string.find(name,"%u",2)
		while i~=nil do
			name=string.sub(name,0,i-1).." "..string.sub(name,i)
			i=string.find(name,"%u",i+2) -- increment by 2 since we just added a padding space
		end
		local bold=not(string.find(name," Bold",1,true)==nil)
		Turbine.UI.Lotro.FontInfo[v]={["name"]=name,["size"]=size,["bold"]=bold}
	end
end

FontMetric = class( Turbine.UI.Label );
function FontMetric:Constructor()
	Turbine.UI.Control.Constructor( self );
	self.Text=Turbine.UI.Label();
	self.Text:SetParent(self);
	self.VScroll=Turbine.UI.Lotro.ScrollBar();
	self.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.VScroll:SetParent(self);
	self.Text:SetVerticalScrollBar(self.VScroll);
	self.HScroll=Turbine.UI.Lotro.ScrollBar();
	self.HScroll:SetOrientation(Turbine.UI.Orientation.Horizontal);
	self.HScroll:SetParent(self);
	self.Text:SetHorizontalScrollBar(self.HScroll);
	self.fontHeight=12;
	self.SetFont=function(sender,font)
		self.Text:SetFont(font);
		self.fontHeight=Turbine.UI.Lotro.FontInfo[font].size
	end
	self.GetTextWidth=function(sender,text,height)
		if height==nil or height<self.fontHeight then height=self.fontHeight end
		self.Text:SetHeight(height);
		self.Text:SetMultiline(false);
		local width=string.len(text);
		self.Text:SetText(text);
		self.Text:SetWidth(width);
		while self.HScroll:IsVisible() do
			width=width+1;
			self.Text:SetWidth(width);
		end
		return width;
	end
	self.GetTextHeight=function(sender,text,width)
		if width~=nil then self.Text:SetWidth(width) end
		self.Text:SetMultiline(true);
		local height=self.fontHeight;
		self.Text:SetText(text);
		self.Text:SetHeight(height);
		while self.HScroll:IsVisible() or self.VScroll:IsVisible() do
			height=height+1;
			self.Text:SetHeight(height);
		end
		return height;
	end

end